/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.evasion.client.controler.booktravel.secure;

import com.evasion.common.Constante;
import com.evasion.common.LocationConverter;
import com.evasion.ejb.local.ParametreManagerLocal;
import com.evasion.ejb.remote.GeolocEJBRemote;
import com.evasion.entity.booktravel.Itinerary;
import com.evasion.entity.booktravel.RoadMap;
import com.evasion.entity.content.Contribution;
import com.evasion.entity.geolocation.Location;
import com.evasion.exception.EvasionException;
import com.evasion.module.travel.ITravelModule;
import java.util.ArrayList;
import java.util.List;
import javax.annotation.PostConstruct;
import javax.ejb.EJB;
import javax.ejb.EJBException;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 *
 * @author sebastien
 */
@ManagedBean()
@ViewScoped
public class RoadmapForm {

    /**
     * Logger *
     */
    private static final Logger LOGGER = LoggerFactory.getLogger(RoadmapForm.class);
    @EJB
    private ITravelModule bookTravelEJB;
    @EJB
    private ParametreManagerLocal paramEJB;
    @EJB
    private GeolocEJBRemote geolocEJB;
    private RoadMap roadMap;
    private List<Location> selectedBreakPoints;
    List<Location> locs = new ArrayList<Location>();
    private Long currentBookTravelID;
    
    @PostConstruct
    public void init() {
        LOGGER.debug("Initialisation du Bean Manager IndexAdminBookTravel");
        FacesContext ctx = FacesContext.getCurrentInstance();
        roadMap = (RoadMap) ctx.getExternalContext().getSessionMap().
                get("currentRoadMap");
                        currentBookTravelID = (Long) FacesContext.getCurrentInstance().
                        getExternalContext().getSessionMap().
                        get("currentBookTravelID");
        if (roadMap == null) {
            LOGGER.debug("Initialisation de la roadMap");
            final Contribution contrib = new Contribution("", "", null);
            final Itinerary itin = new Itinerary();
            // @TODO terminer d'implémenter la création des itinéraire.
            roadMap = new RoadMap(contrib, itin, null);
        }
    }

    public String annulContribution() {
        FacesContext ctx = FacesContext.getCurrentInstance();
        ctx.getExternalContext().getSessionMap().remove("currentRoadMap");
        return "booktravel/index.xhtml";
    }

    /**
     * Action de validation du formulaire.
     *
     * @return
     * <code>Constante.FAIL_ACTION</code> si erreur de lavalidation; <br> sinon
     * renvoi la page de destination.
     */
    public String validContribution() {
        LOGGER.debug("Demande de validation d'une contribution au sein d'une roadMap");
        String result = null;
        try {
            roadMap.getItinerary().updateBreakPoint(selectedBreakPoints);
            bookTravelEJB.createRoadMap(currentBookTravelID,
                    roadMap.getContribution(), roadMap.getItinerary());
        } catch (EvasionException ex) {
            FacesContext ctx = FacesContext.getCurrentInstance();
            ctx.getExternalContext().getSessionMap().remove("currentRoadMap");
            FacesContext.getCurrentInstance().addMessage(null,
                    new FacesMessage(FacesMessage.SEVERITY_ERROR,
                    "Erreur dans la création/modification de la feuille de route", ex.toString()));
            result = Constante.FAIL_ACTION;
        } catch (EJBException ex) {
            LOGGER.error("Erreur technique sur appel des couche métier", ex);
            FacesContext ctx = FacesContext.getCurrentInstance();
            ctx.getExternalContext().getSessionMap().remove("currentRoadMap");
            FacesContext.getCurrentInstance().addMessage(null,
                    new FacesMessage(FacesMessage.SEVERITY_ERROR,
                    "Erreur d'appel des couche métier", ex.toString()));
            result = Constante.FAIL_ACTION;
        }
        if (result == null) {
            FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO,
                    "Les données ont été correctement sauvegardé", ""));
            result = Constante.SUCCESS_ACTION;
        }
        return result;

    }

    public List<Location> complete(String query) {
        try {
            locs = geolocEJB.searchFullTextLocation(query);

        } catch (EvasionException ex) {
            LOGGER.error("Erreur de recherche sur autocomplétion des localisation", ex);
        }
        return locs;
    }

    public List<Location> getFetchedResult() {
        return locs;
    }

    public RoadMap getRoadMap() {
        return roadMap;
    }

    public void setRoadMap(RoadMap roadMap) {
        this.roadMap = roadMap;
    }

    public void setBookTravelEJB(ITravelModule bookTravelEJB) {
        this.bookTravelEJB = bookTravelEJB;
    }

    public ParametreManagerLocal getParamEJB() {
        return paramEJB;
    }

    public void setParamEJB(ParametreManagerLocal paramEJB) {
        this.paramEJB = paramEJB;
    }

    public List<Location> getSelectedBreakPoints() {
        if (selectedBreakPoints == null) {
            selectedBreakPoints = new ArrayList<Location>(1);
            selectedBreakPoints.add(new Location());
        }
        return selectedBreakPoints;
    }

    public void setSelectedBreakPoints(List<Location> breakPoints) {
        this.selectedBreakPoints = breakPoints;
    }

    public Converter getConverter() {
        return new LocationConverter(locs);
    }
}
